/*!
*
*       JSMatrix : JavaScript matrix and vector implementation
*                      version 0.5 (2011-09-19)
*
*                 Copyright (C)  2011  Jan Stransky
*
*      Czech Technical University, Faculty of Civil Engineering,
*  Department of Structural Mechanics, 166 29 Prague, Czech Republic
*
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
var JSM_GAUSS=1;var JSM_GAUSSJORDAN=2;var JSM_LU=3;var JSM_LDU=4;var JSM_CHOLESKY=5;var JSM_QR=6;var JSM_INV_IT=7;var JSM_SUBSPACE=8;var JSM_NOPIVOT=9;var JSM_PARTPIVOT=10;var JSM_FULLPIVOT=11;var X=0;var Y=1;var Z=2;var JSM_TOL=1e-8;var JSM_DEBUG=0;if(JSM_DEBUG){assert=function(a,b){if(!a){alert("JSM_DEBUG:\n"+(b||""))}}}else{assert=function(){}}Vector=function(){this.nItems=0;this.theArray=[]};Vector.prototype={zero:function(){for(var a=0;a<this.nItems;a++){this.theArray[a]=0}},size:function(){return this.nItems},isEqualTo:function(b){if(!this.isSameSizeAs(b)){return false}var a=b.theArray;for(var c=0;c<this.nItems;c++){if(Math.abs(this.theArray[c]-a[c])>JSM_TOL){return false}}return true},get:function(a){return this.theArray[a]},set:function(a,b){this.theArray[a]=b},incr:function(a,b){if(b){this.theArray[a]+=b}},isSameSizeAs:function(a){return(this.nItems==a.nItems)},canMultiplyMat:function(a){return this.nItems==a.nCols},fromArray:function(a){this.nItems=a.length;this.theArray=a.slice()},toArray:function(){return this.theArray.slice()},add:function(c){if(!this.isSameSizeAs(c)){return null}var a=c.theArray;var b=[];for(var d=0;d<this.nItems;d++){b[d]=this.theArray[d]+a[d]}return Vector.create(b)},iadd:function(b){if(!this.isSameSizeAs(b)){return null}var a=b.theArray;for(var c=0;c<this.nItems;c++){this.theArray[c]+=a[c]}},sub:function(c){if(!this.isSameSizeAs(c)){return null}var a=c.theArray;var b=[];for(var d=0;d<this.nItems;d++){b[d]=this.theArray[d]-a[d]}return Vector.create(b)},isub:function(b){if(!this.isSameSizeAs(b)){return null}var a=b.theArray;for(var c=0;c<this.nItems;c++){this.theArray[c]-=a[c]}},dot:function(c,e){var e=e||0;if(e<=0||e>this.nItems){e=this.nItems}if(e>c.nItems){return null}var a=c.theArray;var b=0;for(var d=0;d<e;d++){b+=this.theArray[d]*a[d]}return b},squaredNorm:function(){return this.dot(this)},norm:function(){return Math.sqrt(this.dot(this))},normalize:function(){var a=this.norm();this.imulf(1/a)},normalized:function(){var a=this.copy();a.normalize();return a},outer:function(d){var b=[];var a=d.theArray;for(var e=0;e<this.nItems;e++){b[e]=[];for(var f=0;f<a.length;f++){b[e][f]=this.theArray[e]*a[f]}}return Matrix.create(b)},cross:function(b){if(this.nItems!=3||b.nItems!=3){return null}var a=b.theArray;return Vector.create([this.theArray[Y]*a[Z]-this.theArray[Z]*a[Y],this.theArray[Z]*a[X]-this.theArray[X]*a[Z],this.theArray[X]*a[Y]-this.theArray[Y]*a[X]])},negated:function(){var a=this.copy();return a.mulf(-1)},neg:function(){return this.negated()},negate:function(){for(var a=0;a<this.nItems;a++){this.theArray[a]*=-1}},ineg:function(){this.negate()},mulf:function(c){var a=[];for(var b=0;b<this.nItems;b++){a[b]=c*this.theArray[b]}return Vector.create(a)},imulf:function(b){for(var a=0;a<this.nItems;a++){this.theArray[a]*=b}},mulm:function(e){if(!this.canMultiplyMat(e)){return null}var a=e.theArray;var d=[];var b;for(var g=0;g<e.nCols;g++){b=0;for(var f=0;f<this.nItems;f++){b+=this.theArray[f]*a[f][g]}d[g]=b}return Vector.create(d)},mul:function(a){if(a instanceof Matrix){return this.mulm(a)}if(typeof a=="number"){return this.mulf(a)}return null},x:function(a){return this.mul(a)},getsv:function(a){var a=a.theArray||a;var d=a.length;var b=[];for(var c=0;c<d;c++){b[c]=this.theArray[a[c]]}return Vector.create(b)},setsv:function(b,c){var a=c.theArray||c;var b=b.theArray||b;var e=b.length;if(a.length!=e){return}for(var d=0;d<e;d++){this.theArray[b[d]]=a[d]}},incrsv:function(b,c){var a=c.theArray||c;var b=b.theArray||b;var e=b.length;if(a.length!=e){return}for(var d=0;d<e;d++){this.theArray[b[d]]+=a[d]}},decrsv:function(b,c){var a=c.theArray||c;var b=b.theArray||b;var e=b.length;if(a.length!=e){return}for(var d=0;d<e;d++){this.theArray[b[d]]-=a[d]}},copy:function(){var a=new Vector();a.fromArray(this.theArray.slice());return a},toString:function(){var c=this.nItems;if(c==0){return"Vector([])\n"}var a="Vector([ ";for(var b=0;b<c-1;b++){a+=this.theArray[b]+", "}a+=this.theArray[c-1]+" ])\n";return a},swapItems:function(b,a){var c=this.theArray[b];this.theArray[b]=this.theArray[a];this.theArray[a]=c},appendItems:function(a){if(a instanceof Vector){for(var b=0;b<a.nItems;b++){this.theArray[this.nItems]=a.theArray[b];this.nItems++}return}if(a instanceof Array){for(var c=0;c<a.length;c++){this.appendItems(a[c])}return}if(typeof a=="number"){this.theArray[this.nItems]=a;this.nItems++;return}},permuteItems:function(c,d){var c=c.theArray||c;if(c.length!=this.nItems){return}var d=d||false;var b=[];if(d){for(var a=0;a<this.nItems;a++){b[a]=this.theArray[c.indexOf(a)]}this.fromArray(b);return}for(var a=0;a<this.nItems;a++){b[a]=this.theArray[c[a]]}this.fromArray(b)},itemPermutation:function(b,c){var b=b.theArray||b;if(b.length!=this.nItems){return null}var a=this.copy();a.permuteItems(b,c);return a},resize:function(b){if(b==this.nItems){return}if(b>this.nItems){for(var a=this.nItems;a<b;a++){this.theArray[a]=0}this.nItems=b;return}if(b<this.nItems){this.theArray=this.theArray.slice(0,b);this.nItems=b}},resized:function(b){var a=this.copy();a.resize(b);return a},toDiagonalMatrix:function(){var a=Matrix.Zeros(this.nItems,this.nItems);for(var b=0;b<this.nItems;b++){a.theArray[b][b]=this.theArray[b]}return a},diag:function(){return this.toDiagonalMatrix()},};Vector.create=function(d){var b=(d==null)?[]:d.slice();var c=new Vector();c.fromArray(b);return c};Vector.UnitX=Vector.create([1,0,0]);Vector.UnitY=Vector.create([0,1,0]);Vector.UnitZ=Vector.create([0,0,1]);Vector.Zeros=function(c){var c=c||0;var b=[];for(var a=0;a<c;a++){b.push(0)}return Vector.create(b)};Vector.Ones=function(c){var c=c||0;var b=[];for(var a=0;a<c;a++){b.push(1)}return Vector.create(b)};Matrix=function(a,b){this.nRows=a||1;this.nCols=b||0;this.theArray=[[]]};Matrix.prototype={zero:function(){for(var a=0;a<this.nRows;a++){this.theArray[a]=[];for(var b=0;b<this.nCols;b++){this.theArray[a][b]=0}}},size:function(){return[this.nRows,this.nCols]},isEqualTo:function(b){if(!this.isSameSizeAs(b)){return false}var a=b.theArray;for(var d=0;d<this.nRows;d++){for(var e=0;e<this.nCols;e++){if(Math.abs(this.theArray[d][e]-a[d][e])>JSM_TOL){return false}}}return true},get:function(a,b){return this.theArray[a][b]},set:function(a,d,b){this.theArray[a][d]=b},incr:function(a,d,b){if(b){this.theArray[a][d]+=b}},isSameSizeAs:function(a){return(this.nRows==a.nRows&&this.nCols==a.nCols)},canMultiplyMat:function(a){return(this.nCols==a.nRows)},canMultiplyVec:function(a){return(this.nCols==a.nItems)},isSquare:function(){return(this.nRows==this.nCols)},isSymmetric:function(){if(!this.isSquare()){return false}for(var a=0;a<this.nRows;a++){for(var b=a+1;b<this.nCols;b++){if(Math.abs(this.theArray[a][b]-this.theArray[b][a])>JSM_TOL){return false}}}return true},isLowerTriangular:function(){for(var a=0;a<this.nRows;a++){for(var b=a+1;b<this.nCols;b++){if(Math.abs(this.theArray[a][b])>JSM_TOL){return false}}}return true},isUpperTriangular:function(){for(var a=0;a<this.nRows;a++){for(var b=0;b<a;b++){if(Math.abs(this.theArray[a][b])>JSM_TOL){return false}}}return true},fromArray:function(b){this.nRows=b.length;if(this.nRows){this.nCols=b[0].length}else{this.nCols=0}this.theArray=[];for(var a=0;a<this.nRows;a++){this.theArray[a]=b[a].slice()}},toArray:function(){var a=[];for(var b=0;b<this.nRows;b++){a[b]=this.theArray[b].slice()}return a},add:function(d){if(!this.isSameSizeAs(d)){return null}var a=d.theArray;var b=[];for(var e=0;e<this.nRows;e++){b[e]=[];for(var f=0;f<this.nCols;f++){b[e][f]=this.theArray[e][f]+a[e][f]}}return Matrix.create(b)},iadd:function(b){if(!this.isSameSizeAs(b)){return null}var a=b.theArray;for(var d=0;d<this.nRows;d++){for(var e=0;e<this.nCols;e++){this.theArray[d][e]+=a[d][e]}}},sub:function(d){if(!this.isSameSizeAs(d)){return null}var a=d.theArray;var b=[];for(var e=0;e<this.nRows;e++){b[e]=[];for(var f=0;f<this.nCols;f++){b[e][f]=this.theArray[e][f]-a[e][f]}}return Matrix.create(b)},isub:function(b){if(!this.isSameSizeAs(b)){return null}var a=b.theArray;for(var d=0;d<this.nRows;d++){for(var e=0;e<this.nCols;e++){this.theArray[d][e]-=a[d][e]}}},negated:function(){var a=this.copy();return a.mulf(-1)},neg:function(){return this.negated()},negate:function(){for(var a=0;a<this.nRows;a++){for(var b=0;b<this.nCols;b++){this.theArray[a][b]*=-1}}},ineg:function(){this.negate()},getRow:function(a){return Vector.create(this.theArray[a].slice())},getCol:function(d){var a=[];for(var b=0;b<this.nRows;b++){a[b]=this.theArray[b][d]}return Vector.create(a)},setRow:function(c,b){if(this.nCols!=b.nItems){return}var a=b.theArray;this.theArray[c]=a.slice()},setCol:function(e,b){if(this.nRows!=b.nItems){return}var a=b.theArray;for(var d=0;d<this.nRows;d++){this.theArray[d][e]=a[d]}},swapRows:function(b,a){var c=this.theArray[b];this.theArray[b]=this.theArray[a];this.theArray[a]=c},swapCols:function(c,b){var a;for(var d=0;d<this.nRows;d++){a=this.theArray[d][c];this.theArray[d][c]=this.theArray[d][b];this.theArray[d][b]=a}},permuteRows:function(c,d){var c=c.theArray||c;if(c.length!=this.nRows){return null}var d=d||false;var b=[];if(d){for(var a=0;a<this.nRows;a++){b[a]=this.theArray[c.indexOf(a)].slice()}this.fromArray(b);return}for(var a=0;a<this.nRows;a++){b[a]=this.theArray[c[a]].slice()}this.fromArray(b)},rowPermutation:function(b,c){var b=b.theArray||b;var c=c||false;if(b.length!=this.nRows){return null}var a=this.copy();a.permuteRows(b,c);return a},mulf:function(b){var a=this.copy();a.imulf(b);return a},imulf:function(b){for(var a=0;a<this.nRows;a++){for(var d=0;d<this.nCols;d++){this.theArray[a][d]*=b}}},mulv:function(e){if(!this.canMultiplyVec(e)){return null}var b=e.theArray;var d=[];var a;for(var f=0;f<this.nRows;f++){a=0;for(var g=0;g<this.nCols;g++){a+=this.theArray[f][g]*b[g]}d[f]=a}return Vector.create(d)},mulm:function(f){if(!this.canMultiplyMat(f)){return null}var a=f.theArray;var e=[];var d;for(var g=0;g<this.nRows;g++){e[g]=[];for(var h=0;h<f.nCols;h++){d=0;for(var b=0;b<this.nCols;b++){d+=this.theArray[g][b]*a[b][h]}e[g][h]=d}}return Matrix.create(e)},mul:function(a){if(a instanceof Vector){return this.mulv(a)}if(a instanceof Matrix){return this.mulm(a)}if(typeof a=="number"){return this.mulf(a)}return null},x:function(a){return this.mul(a)},transposed:function(){var a=[];for(var b=0;b<this.nCols;b++){a[b]=[];for(var d=0;d<this.nRows;d++){a[b][d]=this.theArray[d][b]}}return Matrix.create(a)},T:function(){return this.transposed()},getsm:function(e,f){var d=e.nItems||e.length;var h=f.nItems||f.length;var e=e.theArray||e;var f=f.theArray||f;var a=[];for(var b=0;b<d;b++){a[b]=[];for(var g=0;g<h;g++){a[b][g]=this.theArray[e[b]][f[g]]}}return Matrix.create(a)},setsm:function(f,g,b){var f=f.theArray||f;var g=g.theArray||g;var e=f.length;var l=g.length;if(b.nRows!=e||b.nCols!=l){return}var a=b.theArray;for(var d=0;d<e;d++){for(var h=0;h<l;h++){this.theArray[f[d]][g[h]]=a[d][h]}}},incrsm:function(f,g,b){var f=f.theArray||f;var g=g.theArray||g;var e=f.length;var l=g.length;if(b.nRows!=e||b.nCols!=l){return}var a=b.theArray;for(var d=0;d<e;d++){for(var h=0;h<l;h++){this.theArray[f[d]][g[h]]+=a[d][h]}}},decrsm:function(f,g,b){var f=f.theArray||f;var g=g.theArray||g;var e=f.length;var l=g.length;if(b.nRows!=e||b.nCols!=l){return}var a=b.theArray;for(var d=0;d<e;d++){for(var h=0;h<l;h++){this.theArray[f[d]][g[h]]-=a[d][h]}}},copy:function(){var a=[];for(var b=0;b<this.nRows;b++){a[b]=this.theArray[b].slice()}return Matrix.create(a)},diagonalToVector:function(){if(!this.isSquare()){return null}var a=[];for(var b=0;b<this.nRows;b++){a[b]=this.theArray[b][b]}return Vector.create(a)},diag:function(){return this.diagonalToVector()},toString:function(){var d=this.nRows;var f=this.nCols;var a="Matrix([[ ";if(d==0){return a+"])"}if(f==0){for(var b=0;b<d-1;b++){a+=" [],"}return a+" ])"}for(var b=0;b<d-1;b++){for(var e=0;e<f-1;e++){a+=this.theArray[b][e]+", "}a+=this.theArray[b][f-1]+" ], [ "}for(var e=0;e<f-1;e++){a+=this.theArray[d-1][e]+", "}a+=this.theArray[d-1][f-1]+" ]])";return a},resize:function(a,b){if(this.nRows<a){for(var d=this.nRows;d<a;d++){this.setRow(d,Vector.Zeros(this.nCols))}this.nRows=a}if(this.nRows>a){this.theArray=this.theArray.slice(0,a);this.nRows=a}if(this.nCols<b){for(var d=0;d<this.nRows;d++){for(var e=this.nCols;e<b;e++){this.theArray[d][e]=0}}this.nCols=b}if(this.nCols>b){for(var d=0;d<this.nRows;d++){this.theArray[d]=this.theArray[d].slice(0,b)}this.nCols=b}},resized:function(b,c){var a=this.copy();a.resize(b,c);return a},appendRows:function(c){if(c instanceof Vector){if(c.nItems!=this.nCols){return}this.theArray[this.nRows]=c.theArray.slice();this.nRows++;return}if(c instanceof Matrix){if(c.nCols!=this.nCols){return}for(var b=0;b<c.nRows;b++){this.theArray[this.nRows]=c.theArray[b].slice();this.nRows++}return}if(c instanceof Array){for(var a=0;a<c.length;a++){this.appendRows(c[a])}}},appendCols:function(d){if(d instanceof Vector){if(d.nItems!=this.nRows){return}for(var b=0;b<this.nRows;b++){this.theArray[b][this.nCols]=d.theArray[b]}this.nCols++;return}if(d instanceof Matrix){if(d.nRows!=this.nRows){return}for(var b=0;b<d.nRows;b++){for(var e=0;e<d.nCols;e++){this.theArray[b][this.nCols+e]=d.theArray[b][e]}}this.nCols+=d.nCols;return}if(d instanceof Array){for(var a=0;a<d.length;a++){this.appendCols(d[a])}}},implicitPartialPivotPermutation:function(h){var h=h==undefined?true:h;var a=this.nRows;var g=h?this.copy():this;var l=[];var f=range(a);var b,e,d,c;for(e=0;e<a;e++){b=0;for(d=0;d<a;d++){if((temp=Math.abs(g.theArray[e][d]))>b){b=temp}}if(b==0){return null}l[e]=1/b}for(c=0;c<a;c++){b=0;for(e=c;e<a;e++){temp=l[e]*Math.abs(g.theArray[e][c]);if(temp>b){b=temp;imax=e}}if(c!=imax){g.swapRows(c,imax);l[imax]=l[c];temp=f[c];f[c]=imax;f[imax]=temp}}return[g,f]},forwardSubstitution:function(f,d){if(!this.isSquare()||!this.canMultiplyVec(f)){return null}var d=d==undefined?true:d;var a;var g=this.nRows;var c=d?f.copy():f;var e,b;for(var e=0;e<g;e++){a=c.theArray[e];for(var b=0;b<e;b++){a-=this.theArray[e][b]*c.theArray[b]}c.theArray[e]=a/this.theArray[e][e]}return c},backwardSubstitution:function(f,d){if(!this.isSquare()||!this.canMultiplyVec(f)){return null}var d=d==undefined?true:d;var a;var g=this.nRows;var c=d?f.copy():f;var e,b;for(e=g-1;e>=0;e--){a=c.theArray[e];for(b=e+1;b<g;b++){a-=this.theArray[e][b]*c.theArray[b]}c.theArray[e]=a/this.theArray[e][e]}return c},gaussianElimination:function(h,c,l){if(!this.canMultiplyVec(h)||!this.isSquare()){return null}var c=c||JSM_PARTPIVOT;var l=l==undefined?true:l;var d=this.nRows;var g,f,e;if(c==JSM_NOPIVOT){var o=l?this.copy():this;var m=l?h.copy():h;for(e=0;e<d-1;e++){akk=o.theArray[e][e];for(g=e+1;g<d;g++){for(f=e+1;f<d;f++){o.theArray[g][f]-=o.theArray[e][f]*o.theArray[g][e]/akk}m.theArray[g]-=m.theArray[e]*o.theArray[g][e]/akk}}return o.backwardSubstitution(m,false)}if(c==JSM_PARTPIVOT){var o=this.implicitPartialPivotPermutation(l);return o[0].gaussianElimination((l?h.copy():h).itemPermutation(o[1]),JSM_NOPIVOT,false)}},gaussJordanElimination:function(m,c,o){if(!this.isSquare){return null}var m=m||null;if(m==null){return null}var d=(m instanceof Vector)?1:((m instanceof Array)?2:((m instanceof Matrix)?3:4));if(!(d==1||d==2||d==3)){return null}var c=c||JSM_PARTPIVOT;var o=o==undefined?true:o;var l,h,g,f;var e=this.nRows;var s=d==2?m.length:(d==3?m.nCols:0);if(c==JSM_NOPIVOT){var q=o?this.copy():this;var p;if(d==1||d==3){p=o?m.copy():m}else{p=[];for(l=0;l<s;l++){p[l]=o?m[l].copy():m[l]}}for(g=0;g<e;g++){f=q.theArray[g][g];for(l=g+1;l<e;l++){for(h=g+1;h<e;h++){q.theArray[l][h]-=q.theArray[g][h]*q.theArray[l][g]/f}switch(d){case 1:p.theArray[l]-=p.theArray[g]*q.theArray[l][g]/f;break;case 2:for(h=0;h<s;h++){p[h].theArray[l]-=p[h].theArray[g]*q.theArray[l][g]/f}break;case 3:for(h=0;h<s;h++){p.theArray[l][h]-=p.theArray[g][h]*q.theArray[l][g]/f}break}}}for(g=e-1;g>=0;g--){f=q.theArray[g][g];for(l=g-1;l>=0;l--){for(h=e-1;h>g;h--){q.theArray[l][h]-=q.theArray[g][h]*q.theArray[l][g]/f}switch(d){case 1:p.theArray[l]-=p.theArray[g]*q.theArray[l][g]/f;break;case 2:for(h=0;h<s;h++){p[h].theArray[l]-=p[h].theArray[g]*q.theArray[l][g]/f}break;case 3:for(h=0;h<s;h++){p.theArray[l][h]-=p.theArray[g][h]*q.theArray[l][g]/f}break}}}for(g=0;g<e;g++){f=q.theArray[g][g];switch(d){case 1:p.theArray[g]/=f;break;case 2:for(h=0;h<s;h++){p[h].theArray[g]/=f}break;case 3:for(h=0;h<s;h++){p.theArray[g][h]/=f}break}}return p}if(c==JSM_PARTPIVOT){var q=this.implicitPartialPivotPermutation(o);var r;switch(d){case 1:r=o?m.copy():m;r.permuteItems(q[1]);break;case 2:r=[];for(l=0;l<s;l++){r[l]=o?m[l].copy():m[l];r[l].permuteItems(q[1])}break;case 3:r=o?m.copy():m;r.permuteRows(q[1]);break}return q[0].gaussJordanElimination(r,JSM_NOPIVOT,false)}},choleskyDecomposition:function(){if(!this.isSquare()){return null}if(!this.isSymmetric()){return null}var g=this.nRows;var d=Matrix.Zeros(g,g);var f,b,e,c,a;for(e=0;e<g;e++){f=this.theArray[e][e];for(a=0;a<e;a++){f-=d.theArray[e][a]*d.theArray[e][a]}if(f<=0){return null}f=Math.sqrt(f);d.theArray[e][e]=f;for(c=e;c<g;c++){b=this.theArray[e][c];for(a=0;a<e;a++){b-=d.theArray[e][a]*d.theArray[c][a]}d.theArray[c][e]=b/f}}return d},chol:function(){return this.choleskyDecomposition()},lltDecomposition:function(){return this.choleskyDecomposition()},luDecomposition:function(b){if(!this.isSquare()){return null}var b=b||JSM_NOPIVOT;var c=this.nRows;var d=Matrix.Zeros(c,c);var q=Matrix.Zeros(c,c);var h,g,f,e;var p;if(b==JSM_NOPIVOT){for(f=0;f<c;f++){d.theArray[f][f]=1;for(g=f;g<c;g++){p=this.theArray[f][g];for(h=0;h<f;h++){p-=d.theArray[f][h]*q.theArray[h][g]}q.theArray[f][g]=p}for(g=f+1;g<c;g++){p=this.theArray[g][f];for(h=0;h<f;h++){p-=d.theArray[g][h]*q.theArray[h][f]}d.theArray[g][f]=p/q.theArray[f][f]}}return[d,q]}if(b==JSM_PARTPIVOT){var o=this.implicitPartialPivotPermutation();var m=o[0].luDecomposition(JSM_NOPIVOT);m[2]=o[1];return m}},lduDecomposition:function(b,c){if(!this.isSquare()){return null}var b=b||JSM_NOPIVOT;var c=c||false;if(b==JSM_NOPIVOT){var e=this.nRows;var f=zeros(e,e);var p=zeros(e);var r=zeros(e,e);var s;for(var m=0;m<e;m++){f.theArray[m][m]=1;r.theArray[m][m]=1;for(var h=0;h<m;h++){s=this.theArray[m][h];for(var g=0;g<h;g++){s-=f.theArray[m][g]*p.theArray[g]*r.theArray[g][h]}f.theArray[m][h]=s/p.theArray[h]}s=this.theArray[m][m];for(var g=0;g<m;g++){s-=f.theArray[m][g]*p.theArray[g]*r.theArray[g][m]}p.theArray[m]=s;for(var h=m+1;h<e;h++){s=this.theArray[m][h];for(var g=0;g<m;g++){s-=f.theArray[m][g]*p.theArray[g]*r.theArray[g][h]}r.theArray[m][h]=s/p.theArray[m]}}if(c){return[f,p,r]}return[f,p.toDiagonalMatrix(),r]}if(b=JSM_PARTPIVOT){var q=this.implicitPartialPivotPermutation();var o=q.lduDecomposition(JSM_NOPIVOT,c,false);o[3]=q[1];return o}},qrDecomposition:function(p){if(!this.isSquare()){return null}var p=p==undefined?true:p;var e=this.nRows;var l=Matrix.Zeros(e,e);var a=p?this.copy():this;var o=[];var m=[];var f,q,h,g,b;for(k=0;k<e-1;k++){f=0;for(i=k;i<e;i++){f=Math.max(f,Math.abs(a.theArray[i][k]))}if(f==0){b=true;o[k]=0;m[k]=0}else{for(i=k;i<e;i++){a.theArray[i][k]/=f}h=0;for(i=k;i<e;i++){h+=(a.theArray[i][k]*a.theArray[i][k])}q=Math.sqrt(h)*(a.theArray[k][k]>=0?1:-1);a.theArray[k][k]+=q;o[k]=q*a.theArray[k][k];m[k]=-f*q;for(j=k+1;j<e;j++){h=0;for(i=k;i<e;i++){h+=a.theArray[i][k]*a.theArray[i][j]}g=h/o[k];for(i=k;i<e;i++){a.theArray[i][j]-=g*a.theArray[i][k]}}}}m[e-1]=a.theArray[e-1][e-1];if(m[e-1]==0){b=true}for(i=0;i<e;i++){for(j=0;j<e;j++){l.theArray[i][j]=0}l.theArray[i][i]=1}for(k=0;k<e-1;k++){if(o[k]!=0){for(j=0;j<e;j++){h=0;for(i=k;i<e;i++){h+=a.theArray[i][k]*l.theArray[i][j]}h/=o[k];for(i=k;i<e;i++){l.theArray[i][j]-=h*a.theArray[i][k]}}}}for(i=0;i<e;i++){a.theArray[i][i]=m[i];for(j=0;j<i;j++){a.theArray[i][j]=0}}return[l,a]},inversed:function(b,a){if(!this.isSquare){return null}var b=b||JSM_GAUSSJORDAN;switch(b){case JSM_GAUSSJORDAN:return this.gaussJordanElimination(Matrix.Identity(this.nRows,this.nRows));default:return null}},inv:function(b,a){return this.inversed(b||undefined,a||undefined)},determinant:function(f,d){if(!this.isSquare()){return null}var f=f||JSM_LU;var c=d||undefined;switch(f){case JSM_LU:c=d?d:this.luDecomposition();var e=c[1].diag();var a=e.theArray[0];for(var b=1;b<this.nRows;b++){a*=e.theArray[b]}return a;default:return null}},det:function(b,a){return this.determinant(b||undefined,a||undefined)},isSingular:function(){var a=this.determinant();return isNaN(a)?true:(Math.abs(a)<JSM_TOL)},solveForRhs:function(n,b,p,f){var p=p==undefined?true:p;var b=b||JSM_GAUSS;if(b==JSM_GAUSS){return this.gaussianElimination(n,JSM_PARTPIVOT,p)}if(b==JSM_GAUSSJORDAN){return this.gaussJordanElimination(n,JSM_PARTPIVOT,p)}if(b==JSM_LU){var e=f||this.luDecomposition();var c=e[0];var t=e[1];var s;if(n instanceof Vector){s=c.forwardSubstitution(n,p);return t.backwardSubstitution(s,false)}if(n instanceof Matrix){var m=p?Matrix.Zeros(this.nRows,n.nCols):n;for(var g=0;g<n.nCols;g++){s=c.forwardSubstitution(n.getCol(g),false);m.setCol(g,t.backwardSubstitution(s,false))}return m}if(n instanceof Array){return null}}if(b==JSM_LDU){var h=f||this.lduDecomposition(JSM_NOPIVOT,true);var c=h[0];var o=(h[1] instanceof Matrix)?h[1].diag():h[1];var t=h[2];var s=c.forwardSubstitution(n,p);for(var a=0;a<this.nRows;a++){s.theArray[a]/=o.theArray[a]}return t.backwardSubstitution(s,false)}if(b==JSM_CHOLESKY){var c=f||this.choleskyDecomposition();if(c==null){return null}var s=c.forwardSubstitution(n,p);return c.T().backwardSubstitution(s,false)}if(b==JSM_QR){var q=f||this.qrDecomposition(p);return q[1].backwardSubstitution(q[0].mulv(n),false)}return null},};Matrix.create=function(c){var b=(c==null)?[[]]:c;ret=new Matrix();ret.fromArray(b);return ret};Matrix.Diagonal=function(a){return Vector.create(a.theArray||a).diag()};Matrix.Identity=function(d){var b=[];for(var c=0;c<d;c++){b[c]=1}return Matrix.Diagonal(b)};Matrix.I=function(a){return Matrix.Identity(a)};Matrix.Zeros=function(d,e){var d=d||0;var e=e||0;var b=[];for(var f=0;f<d;f++){b[f]=[];for(var g=0;g<e;g++){b[f][g]=0}}return Matrix.create(b)};Matrix.Ones=function(d,e){var d=d||0;var e=e||0;var b=[];for(var f=0;f<d;f++){b[f]=[];for(var g=0;g<e;g++){b[f][g]=1}}return Matrix.create(b)};mat=function(a){var a=(a==null)?[[]]:a;return Matrix.create(a)};vec=function(a){var a=(a==null)?[]:a;return Vector.create(a)};zeros=function(a,b){if(b){return Matrix.Zeros(a,b)}if(a){return Vector.Zeros(a)}return null};ones=function(a,b){if(b){return Matrix.Ones(a,b)}if(a){return Vector.Ones(a)}return null};identity=function(a){return Matrix.Identity(a)};eye=function(a){return Matrix.Identity(a)};linSolve=function(b,f,c,e,d){return b.solveForRhs(f,c||undefined,e||undefined,d||undefined)};eigSolve=function(f,e,l,d,b){var f=f;var e=e;if(!f.isSquare()||!e.isSquare()||!f.isSameSizeAs(e)){return null}var l=l||1;if(l>f.nRows){l=f.nRows}var d=d||JSM_INV_IT;var b=b||1000;if(d==JSM_INV_IT){var m=f.inv().mulm(e);var u=1e-32;var v=[];var D=[];var h=[];var a,g,w,B;var p=Vector.Zeros(f.nRows);for(var y=0;y<l;y++){p.zero();p.set(0,1);B=0;w=0;do{p=m.mulv(p);for(var z=0;z<y;z++){p.isub(D[z].mulf(h[z].dot(p)))}p.imulf(1/Math.sqrt(p.mulm(e).dot(p)));a=w;w=(p.mulm(f).dot(p))/(p.mulm(e).dot(p));g=Math.abs(w-a)/w;B++;if(B>b){if(g>JSM_TOL){}break}}while(g>u);v.push(w);D.push(p.copy());h.push(p.mulm(e))}return[v,D]}if(d==JSM_SUBSPACE){var t=f.nRows;var c,C,o,E,s;x=Matrix.Ones(t,l);for(var A=0;A<t;A++){x.set(A,A,0)}lu=f.luDecomposition();for(var A=0;A<50;A++){x=f.solveForRhs(e.x(x),JSM_LU,false,lu);c=x.T().x(f).x(x);C=x.T().x(e).x(x);o=eigSolve(c,C,l);s=Matrix.Zeros(l,l);for(var z=0;z<l;z++){s.setCol(z,o[1][z])}x=x.x(s)}E=[[],[]];for(var A=0;A<l;A++){E[0].push(o[0][A]);E[1].push(x.getCol(A))}return E}};range=function(e,d,n){var m;var l;var g;if(d==null&&n==null){m=0;g=e;l=1}else{if(n==null){m=e;g=d;l=1}else{m=e;g=d;l=n}}var f=[];var h=m;while(h<g){f.push(h);h+=l}return f};Array.prototype.indexOf=function(b){for(var a=0;a<this.length;a++){if(this[a]===b){return a}}};